%% Differentialgleichung zu freiem Fall durch viskoses Medium
%

%%
% Es handelt sich hier um ein steifes System zweier
% Differentialgleichungen. Dieses Skript testet, wie gut verschiedene
% Matlab-Lser damit umgehen.

%% Bewegungsgleichung 
% fr Hhe $z(t)$: $\ddot z + D \dot z + 1  = 0 $  mit  $D\gg 1$
% (in geeignet skalierten Einheiten)
% 
% Nach kurzer Zeit $t\approx 1/D$ nahezu konstante Sinkgeschwindigkeit. Ab dann verluft $z(t)$ unspektakulr linear.
%
 
%% Modellparameter und Funktionsdefinition
% mit Umformung: $z = y_1,  \dot z = y_2$

D = 100 ;
f = @(t,y)[  y(2); 
             -1-D*y(2) ];
%% Aufruf des Lsers mit passenden Anfangsbedingungen und Plot
% Der DG-Lser ode45 ist ein Allzweck-Standard-Verfahren. Hier allerdings
% arbeitet er nicht wirklich gut.
opts = odeset('Stats','on');
ode45(f,[0 20],[1,0],opts)

% Beschriftung und Kosmetik
% title 'Fall in viskosem Medium (ode45)'
% xlabel 'Zeit'
% ylabel 'Weg (blau) und Geschwindigkeit (rot)'

%% Andere Lser 
opts = odeset('Stats','on'); 
ode15s(f,[0 20],[1,0],opts)

ode23s(f,[0 20],[1,0],opts)

ode78(f,[0 20],[1,0],opts)


 

